# Copyright (C) 2023-present MongoDB, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the Server Side Public License, version 1,
# as published by MongoDB, Inc.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# Server Side Public License for more details.
#
# You should have received a copy of the Server Side Public License
# along with this program. If not, see
# <http://www.mongodb.com/licensing/server-side-public-license>.
#
# As a special exception, the copyright holders give permission to link the
# code of portions of this program with the OpenSSL library under certain
# conditions as described in each individual source file and distribute
# linked combinations including the program with the OpenSSL library. You
# must comply with the Server Side Public License in all respects for
# all of the code used other than as permitted herein. If you modify file(s)
# with this exception, you may extend this exception to your version of the
# file(s), but you are not obligated to do so. If you do not wish to do so,
# delete this exception statement from your version. If you delete this
# exception statement from all source files in the program, then also delete
# it in the license file.
#

# BSON validate modes

global:
  cpp_namespace: "mongo"

imports:
  - "mongo/db/basic_types.idl"

enums:
  BSONValidateMode:
    description: "The validate mode that dbCheck will run for BSON consistency checks"
    type: string 
    # kDefault: Only fast structural BSON consistency checks
    # kExtended: Structural BSON consistency and extra fast checks on BSON specifications.
    # kFull: Structural BSON consistency and extra comprehensive checks on BSON specifications.
    values:
      kDefault: "kDefault"
      kExtended: "kExtended"
      kFull: "kFull"

# Server paramaters for validation.
# Range and default value should be kept in sync with src/mongo/bson/bson_validate.h

server_parameters:
  bsonTestValidationVersion:
    description: "The version of the BSON validator that will be used to check correctness of data in test environments"
    set_at: startup
    cpp_vartype: int
    cpp_varname: bsonTestValidationVersion
    validator:
      gte: 1
      lte: 2
    default: 2